#include <stdio.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <graphics.h>
#include <string.h>
#include <dir.h>
#include <stdlib.h>
#include <ctype.h>
#include <signal.h>

#include "ROBOT.H"
#include "ROBOT_RS.H"

/* -------------------------------------------------------- */
int main(void)
{
  int Stop = 0;
  TSeq SequenceActuelle = { NULL, NULL, 0 };
  InitGraphMode();
  AffichePresentation();
  AfficheCredits();
  ActionNRZ(ALL_STOP, 0); /* Initialisation du port */

  do
  {
    Effacer();

    switch(MenuAccueil())
    {
      case 1:
        ChargeSequence(& SequenceActuelle);
      break;
      case 2:
        SaisieSequence(& SequenceActuelle);
      break;
      case 3:
        ExecuteUneSequence(& SequenceActuelle);
      break;
      case 4:
        ExecuteEnBoucle(& SequenceActuelle);
      break;
      case 5:
        Stop = 1;
      break;
    }
  }
  while(Stop == 0);

  ReinitSequence(& SequenceActuelle, 0);
  closegraph();
  return EXIT_SUCCESS;
}

/* -------------------------------------------------------- */
int ReinitSequence(PSeq pSequenceActuelle, int N)
{
  int retour = 1;
  if(pSequenceActuelle->R != NULL)
  {
    free(pSequenceActuelle->R);
    pSequenceActuelle->R = NULL;
  }

  if(pSequenceActuelle->D != NULL)
  {
    free(pSequenceActuelle->D);
    pSequenceActuelle->D = NULL;
  }

  pSequenceActuelle->N = N;

  if(N != 0)
  {
    if((pSequenceActuelle->R = malloc(N * sizeof(_uint8))) == NULL)
    {
      pSequenceActuelle->N = 0;
      retour = 0;
    }
    else
    {
      if((pSequenceActuelle->D = malloc(N * sizeof(_uint16))) == NULL)
      {
        if(pSequenceActuelle->R != NULL)
        {
          free(pSequenceActuelle->R);
          pSequenceActuelle->R = NULL;
        }
        pSequenceActuelle->N = 0;
        retour = 0;
      }
    }
  }
  return retour;
}

/* -------------------------------------------------------- */
void SaisieSequence(PSeq pSequenceActuelle)
{
  char bouffeur[20];
  int PasSuivant = 0;
  int FinSaisie  = 0;
  int KeyUtile = 0;
  char Key = '\0';
  unsigned int NumeroBit = 0;
  unsigned int BitSelect = 0;
  unsigned int PrecBitSelect = 0;
  unsigned int Facteur = 0;
  unsigned int Bits[8] = {0, 0, 0, 0, 0, 0, 0, 0};
  unsigned int Pas = 1;

  Effacer();

  if(ReinitSequence(pSequenceActuelle, 100) == 0)
  {
    /* Traiter l'erreur, Afficher dans fentre */
    /* Temporaire : */
    printf("! Erreur d'allocation 'saisie'. Peut-tre mmoire insuffisante...\n");
    return;
  }
  else
  {
    Pas = 0;
    FinSaisie = 0;
    Pas  = -1;
    do
    {
      /* Choisir ici une initialisation des bits */
      Pas++;
      PasSuivant = 0;
      BitSelect = 0;
      PrecBitSelect = 0;

      pSequenceActuelle->D[Pas] = DUREE_DEF;
      setfillstyle(SOLID_FILL, CYAN);
      bar(0, 315, 639, 410);
      TraceFenetre(50, 220, 90, 260, WHITE, BLUE);
      outtextxy(60, 230, itoa(Pas + 1, bouffeur, 10));
      setcolor(RED);
      outtextxy(120, 190, "  Bits sur Port //         Dure (en ms)");
      TraceFenetre(100, 220, 380, 260, WHITE, BLUE);
      TraceFenetre(400, 220, 550, 260, WHITE, BLUE);

      for(NumeroBit = 0; NumeroBit < 8; NumeroBit++)
      {
        if(NumeroBit != 0)
        {
          line(100 + NumeroBit * 35, 220, 100 + NumeroBit * 35, 260);
        }
        outtextxy(113 + NumeroBit * 35, 228, BitStr[Bits[NumeroBit]]);
      }
      outtextxy(430, 228, ultoa((unsigned long)pSequenceActuelle->D[Pas], bouffeur, 10));


      do /* Boucle dans un Pas*/
      {
        setfillstyle(SOLID_FILL, WHITE);
        if(PrecBitSelect == 8)
        {
          bar(401, 221, 549, 259);
          outtextxy(430, 228, ultoa((unsigned long)pSequenceActuelle->D[Pas], bouffeur, 10));
        }
        else
        {
          bar(101 + PrecBitSelect * 35, 221, 134 + PrecBitSelect * 35, 259);
          outtextxy(113 + PrecBitSelect * 35, 228, BitStr[Bits[PrecBitSelect]]);
        }

        setfillstyle(SOLID_FILL, LIGHTGRAY);
        if(BitSelect == 8)
        {
          bar(401, 221, 549, 259);
          outtextxy(430, 228, ultoa((unsigned long)pSequenceActuelle->D[Pas], bouffeur, 10));
        }
        else
        {
          bar(101 + BitSelect * 35, 221, 134 + BitSelect * 35, 259);
          outtextxy(113 + BitSelect * 35, 228, BitStr[Bits[BitSelect]]);
        }



        PrecBitSelect = BitSelect;

        do
        {
          KeyUtile = 1;
          switch (Key = getch())
          {
            case CAR_RET:
              if(BitSelect != 8)
              {
                BitSelect++;
              }
              else
              {
                PasSuivant = 1;
              }
              break;



            case RIGHTKEY:
              if(BitSelect != 8) BitSelect++;
              break;

            case LEFTKEY:
              if(BitSelect != 0) BitSelect--;
              break;

            case PLUSKEY:
              if(BitSelect == 8)
              {
                if(pSequenceActuelle->D[Pas] <= 60000 - DUREE_STEP)
                {
                  pSequenceActuelle->D[Pas] += DUREE_STEP;
                }
                else
                {
                  pSequenceActuelle->D[Pas] = 60000;
                }

              }
              break;

            case MOINSKEY:
              if(BitSelect == 8)
              {
                if(pSequenceActuelle->D[Pas] >= DUREE_STEP)
                {
                  pSequenceActuelle->D[Pas] -= DUREE_STEP;
                }
                else
                {
                  pSequenceActuelle->D[Pas] = 0;
                }
              }
              break;

            case BACKSPACE:
              if(BitSelect == 8)
              {
                pSequenceActuelle->D[Pas] /= 10;
              }
              break;

            case DELKEY:
              if(BitSelect == 8)
              {
                pSequenceActuelle->D[Pas] = 0;
              }
              else
              {
                Bits[BitSelect++] = 0;
              }
              break;

            case '1':case '2':case '3':case '4':case '5':
            case '6':case '7':case '8':case '9':case '0':
              if(BitSelect == 8)
              {
              /* traiter la dure */
              pSequenceActuelle->D[Pas] *= 10;
              pSequenceActuelle->D[Pas]  += Key - '0';
              }
              else
              {
                if(Key == '1' || Key == '0')
                {
                  Bits[BitSelect++] = Key - '0';
                }
              }
              break;

            case CTRL_F:
              PasSuivant = 1;
              FinSaisie  = 1;
              break;

            case CTRL_S:
              PasSuivant = 1;
              break;

            default:
              KeyUtile = 0;
          }
        }while(KeyUtile == 0);



      }while(PasSuivant == 0);
      /* Clture de Pas */

      /* Conversion binaire[] -> int */
      for(NumeroBit = 0, pSequenceActuelle->R[Pas] = 0, Facteur = 128; NumeroBit < 8; NumeroBit++)
      {
        if(Bits[NumeroBit] == 1)
        {
          pSequenceActuelle->R[Pas] += Facteur;
        }
        Facteur >>= 1;
      }

    }while(FinSaisie == 0);
    pSequenceActuelle->N = Pas + 1;
    SauveSequence(pSequenceActuelle);

    return;
  }/* if ... else erreur d'allocation initiale*/
}

/* -------------------------------------------------------- */
void ExecuteUneSequence(PSeq pSequenceActuelle)
{
  int Stop = 0;
  int Pas = 1;

  int NumeroBit;

  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 100, getmaxx(), getmaxy() - 50);

  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 315, 639, 410);
  TraceFenetre(50, 220, 90, 260, WHITE, BLUE);
  setcolor(RED);
  outtextxy(120, 190, "  Bits sur Port //         Dure (en ms)");
  TraceFenetre(100, 220, 380, 260, WHITE, BLUE);
  TraceFenetre(400, 220, 550, 260, WHITE, BLUE);
  for(NumeroBit = 1; NumeroBit < 8; NumeroBit++)
  {
    line(100 + NumeroBit * 35, 220, 100 + NumeroBit * 35, 260);
  }

  TraceTest(0, 0, -1);

  do
  {
    TraceFenetre(100, 330, 540, 380, LIGHTCYAN, BLUE);
    outtextxy(120, 333, "Appuyer sur une touche pour excuter");
    outtextxy(120, 353, " ou ESCAPE pour revenir  l'accueil");
    switch(getch())
    {
      case ESCAPE:
        Stop = 1;
      break;
      default:
        TraceFenetre(100, 330, 540, 380, LIGHTCYAN, BLUE);
        outtextxy(135, 343, "        Excution en cours       ");
        for(Pas = 0; Pas < pSequenceActuelle->N; Pas++)
        {
          #ifdef _SIMUL_
          TraceTest(pSequenceActuelle->R[Pas], pSequenceActuelle->D[Pas], Pas);
          #endif
          ActionNRZ(pSequenceActuelle->R[Pas], pSequenceActuelle->D[Pas]);
        }
        ActionNRZ(ALL_STOP, 0);
        TraceTest(0, 0, -1);
        MonBip();
        Stop = 0;
    }
  }
  while(Stop == 0);
  return;
}

/* -------------------------------------------------------- */
void ExecuteEnBoucle(PSeq pSequenceActuelle)
{
  int Pas = 1;
  int fini = 0;

  int NumeroBit;

  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 100, getmaxx(), getmaxy() - 50);

  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 315, 639, 410);
  TraceFenetre(50, 220, 90, 260, WHITE, BLUE);
  setcolor(RED);
  outtextxy(120, 190, "  Bits sur Port //         Dure (en ms)");
  TraceFenetre(100, 220, 380, 260, WHITE, BLUE);
  TraceFenetre(400, 220, 550, 260, WHITE, BLUE);
  for(NumeroBit = 1; NumeroBit < 8; NumeroBit++)
  {
    line(100 + NumeroBit * 35, 220, 100 + NumeroBit * 35, 260);
  }


  TraceTest(0, 0, -1);

  TraceFenetre(100, 330, 540, 380, LIGHTCYAN, BLUE);
  outtextxy(120, 333, "Appuyer sur une touche pour excuter");
  outtextxy(120, 353, " ou Echap pour revenir  l'accueil");
  if(getch() != ESCAPE)
  {
    do
    {
      TraceFenetre(100, 330, 540, 380, LIGHTCYAN, BLUE);
      outtextxy(240, 330, "Echap pour finir");
      outtextxy(110, 353, "Pause/Entre pour suspendre/reprendre");
      for(Pas = 0; Pas < pSequenceActuelle->N; Pas++)
      {
        #ifdef _SIMUL_
        TraceTest(pSequenceActuelle->R[Pas], pSequenceActuelle->D[Pas], Pas);
        #endif
        ActionNRZ(pSequenceActuelle->R[Pas], pSequenceActuelle->D[Pas]);
        if(bioskey(1) != 0)
        {
          if((fini = ((bioskey(0) % 256) == ESCAPE)) != 0)
          {
            break;
          }
        }
      }
      /* MonBip(); */
    }
    while(fini == 0);
  }
  ActionNRZ(ALL_STOP, 0);
  TraceTest(0, 0, -1);
  return;
}

/* -------------------------------------------------------- */
void InitGraphMode(void)
{
  int gdriver = VGA;
  int gmode = 2;
  int errorcode;

  initgraph(& gdriver, & gmode, "");

  errorcode = graphresult();
  if(errorcode < 0) /* erreur dtecte */
  {
    printf("Erreur graphique: %s\n", grapherrormsg(errorcode));
    printf("Frappez SPACE pour stopper:");
    while(getch() != ' ');
    exit(1);
  }
}

/* -------------------------------------------------------- */
void Effacer(void)
{
  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 65, 639, 450);
}

/* -------------------------------------------------------- */
void AffichePresentation(void)
{
  int i;
  int x;

  x = getmaxx() / 2;

  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 0, getmaxx(), getmaxy());
  settextjustify(1, 1);

  settextstyle(1, 0, 3);

  setcolor(BLACK);
  for(i = 0; i < 5; i++)
  {
    outtextxy(x + i, 25 + i, TextePresentation);
  }
  setcolor(WHITE);
  outtextxy(x, 22, TextePresentation);

  settextjustify(0, 2);
}

/* -------------------------------------------------------- */
void AfficheCredits(void)
{
  int i;

  setfillstyle(SOLID_FILL, CYAN);
  bar(0, 445, 639, 479);
  setcolor(BLACK);
  for(i = 0; i < 4; i++)
  {
    settextstyle(1, 0, 2);
    outtextxy(5 + i, 445 + i, NomsAuteurs);
    settextstyle(0, 0, 1);
    outtextxy(80 + i, 456 + i, TitresAuteurs);
  }

  setcolor(WHITE);
  settextstyle(1, 0, 2);
  outtextxy(5, 445, NomsAuteurs);
  settextstyle(0, 0, 1);
  outtextxy(80, 456, TitresAuteurs);
}

/* -------------------------------------------------------- */
void TraceFenetre(int x1, int y1, int x2, int y2, int coul, int coul2)
{
  setfillstyle(SOLID_FILL, BLACK);
  bar(x1 + 5, y1 + 5, x2 + 5, y2 + 5);
  setfillstyle(SOLID_FILL, coul);
  bar(x1, y1, x2, y2);
  setcolor(coul2);
  rectangle(x1, y1, x2, y2);
}

/* -------------------------------------------------------- */
void MonBip(void)
{
  sound(800);
  delay(150);
  nosound();
}

/* -------------------------------------------------------- */
int Saisir(int tay, int col, int lig, GenreSaisie GS)
{
  int i, retour;
  char * dummy = (char *) malloc(tay + 1);
  for(i = 0; i < tay; i++)
  {
    if(GS == GENRE_BIT)
    {
      dummy[i] = '0';
    }
    else
    {
      dummy[i] = ' ';
    }
  }
  dummy[i] = '\0';
  retour = atoi(SaisieChaine(dummy, tay, col, lig));
  free(dummy);
  return retour;
}

/* -------------------------------------------------------- */
char * SaisieChaine(char * bouffeur, int tay, int col, int lig)
{
  char var2[] = "                                       ";
  char aux;
  int i = 0;
  int flag;
  int deb = 0;

  setcolor(GREEN);
  outtextxy(col, lig, "_");
  do
  {
    aux = (char)toupper(bioskey(0));
    if(deb == 0)
    {
      setcolor(WHITE);
      outtextxy(col, lig, "_");
      deb = 1;
      setcolor(GREEN);
    }
    flag = 0;
    if(aux == CAR_RET)
    {
      flag = 1;
      break;
    }
    if(aux == BACKSPACE)
    {
      if(i != 0)
      {
        setcolor(WHITE);
        outtextxy(col, lig, var2);
        i--;
        bouffeur[i] = '\0';
        setcolor(GREEN);
        strcpy(var2, bouffeur);
        strcat(var2, " _");
        outtextxy(col, lig, var2);
      }
    }
    else
    {
      if(i < tay)
      {
        bouffeur[i] = aux;
        bouffeur[i + 1] = '\0';
        i++;
        setcolor(WHITE);
        outtextxy(col, lig, var2);
        setcolor(GREEN);
        strcpy(var2, bouffeur);
        strcat(var2, "_");
        outtextxy(col, lig, var2);
      }
      else
      {
        MonBip();
      }
    }
  }
  while((i < tay) || (!flag));

  if(i > 0)
  {
    setcolor(WHITE);
    outtextxy(col, lig, var2);
    setcolor(GREEN);
    outtextxy(col, lig, bouffeur);
  }
  return bouffeur;
}

/* -------------------------------------------------------- */
void ActionRZ(_uint8 KU, _uint16 D)
{
#ifndef _TEST_
  PUSH_ABCD

  asm mov dx, PORT_PARA;
  asm mov al, KU;
  asm out dx, al;
#endif

  delay(D);

#ifndef _TEST_
  asm mov dx, PORT_PARA;
  asm mov al, ALL_STOP;
  asm out dx, al;

  POP_DCBA
#endif
}

/* -------------------------------------------------------- */
void ActionNRZ(_uint8 KU, _uint16 D)
{
#ifndef _TEST_
  PUSH_ABCD

  asm mov dx, PORT_PARA;
  asm mov al, KU;
  asm out dx, al;

  POP_DCBA
#endif

  delay(D);
  return;
}

/* -------------------------------------------------------- */
void TraceTest(_uint8 octet, _uint16 D, int Pas)
{
  char bouffeur[20];
  int NumeroBit;
  _uint8 b = 128;

  setfillstyle(SOLID_FILL, WHITE);
  bar(50, 220, 90, 260);
  bar(100, 220, 380, 260);
  bar(400, 220, 550, 260);

  outtextxy( 65, 228, itoa(Pas + 1, bouffeur, 10));
  outtextxy(430, 228, ultoa((unsigned long)D, bouffeur, 10));

  for(NumeroBit = 0; NumeroBit < 8; NumeroBit++)
  {
    line(100 + NumeroBit * 35, 220, 100 + NumeroBit * 35, 260);
    if((octet & b) != 0)
    {
      outtextxy(113 + NumeroBit * 35, 228, "1");
    }
    else
    {
      outtextxy(113 + NumeroBit * 35, 228, "0");
    }
    b /= 2;
  }
return;
}

/* -------------------------------------------------------- */
int MenuAccueil(void)
{
  int x0, y0, a0, curseur;
  char Key = 0;
  x0 = 100;
  y0 = 105;
  a0 = 45;


  TraceFenetre(55, 125, 585, 380, LIGHTCYAN, BLUE);
  TraceFenetre(130, 100, 510, 130, WHITE, BLUE);
  settextstyle(1, 0, 2);
  outtextxy(125, 103, MenuPrincipal[0]);

  for(curseur = 1; curseur <= 5; curseur++)
  {
    outtextxy(x0, y0 + (curseur * a0), MenuPrincipal[curseur]);
  }

  curseur = 2;
  Key = UPKEY;

  do
  {
    if(Key == UPKEY && curseur != 1)
    {
      setfillstyle(SOLID_FILL, LIGHTCYAN);
      bar(x0 - 10, y0 - 5 + (curseur * a0), x0 + 450, y0 + (curseur * a0) + 35);
      outtextxy(x0, y0 + (curseur * a0), MenuPrincipal[curseur]);
      curseur--;
      setfillstyle(SOLID_FILL, CYAN);
      bar(x0 - 10, y0 - 5 + (curseur * a0), x0 + 450, y0 + (curseur * a0) + 35);
      outtextxy(x0, y0 + (curseur * a0), MenuPrincipal[curseur]);
    }
    else if(Key == DOWNKEY && curseur != 5)
    {
      setfillstyle(SOLID_FILL, LIGHTCYAN);
      bar(x0 - 10, y0 - 5 + (curseur * a0), x0 + 450, y0 + (curseur * a0) + 35);
      outtextxy(x0, y0 + (curseur * a0), MenuPrincipal[curseur]);
      curseur++;
      setfillstyle(SOLID_FILL, CYAN);
      bar(x0 - 10, y0 - 5 + (curseur * a0), x0 + 450, y0 + (curseur * a0) + 35);
      outtextxy(x0, y0 + (curseur * a0), MenuPrincipal[curseur]);
    }
    Key = getch();
    if(Key == ESCAPE)
    {
      curseur = 5;
      Key = CAR_RET;
    }
  }
  while(Key != CAR_RET);

  return curseur;
}

/* -------------------------------------------------------- */
int SauveSequence(PSeq pSequenceActuelle)
{
  FILE * frobot = NULL;
  int Pas = 0;
  int retour = 0;
  char * NomFichier = "            ";

  AfficheFichiers(MasqueSequences, FILE_SAUVE);

  strcat(SaisieChaine(NomFichier, 8, 340, 414), ExtensionSequences);
  Effacer();

  if((frobot = fopen(NomFichier, "w")) == NULL)
  {
    printf("Erreur ouverture fichier: %s\n", NomFichier);
    system("PAUSE");
    InitGraphMode();
    AffichePresentation();
    AfficheCredits();
    retour = 1;
  }
  else
  {
    fseek(frobot, 0, SEEK_SET);

    fprintf(frobot, "%s\n", Sesame);
    fprintf(frobot, "%i\n", pSequenceActuelle->N);
    for(Pas = 0; Pas < pSequenceActuelle->N; Pas++)
    {
      fprintf(frobot, "%i\n", pSequenceActuelle->R[Pas]);
      fprintf(frobot, "%i\n", pSequenceActuelle->D[Pas]);
    }
    fclose(frobot);
  }
  return retour;
}

/* -------------------------------------------------------- */
int ChargeSequence(PSeq pSequenceActuelle)
{
  FILE * frobot = NULL;
  int Pas = 0;
  /* Numro du pas */
  int NombrePas = 0;
  char * NomFichier = "            ";
  char * CtrlSesame[20];

  Effacer();
  AfficheFichiers(MasqueSequences, FILE_CHARGE);
  strcat(SaisieChaine(NomFichier, 8, 340, 414), ExtensionSequences);
  Effacer();

  if((frobot = fopen(NomFichier, "r")) == NULL)
  {
    printf("Erreur ouverture fichier: %s\n", NomFichier);
    system("PAUSE");
    InitGraphMode();
    AffichePresentation();
    AfficheCredits();
    return 1;
  }
  else
  {
    fseek(frobot, 0, SEEK_SET);
    fscanf(frobot, "%20s\n", CtrlSesame);
    if(strcmp((const char *) CtrlSesame, Sesame) != 0)
    {
      printf("Erreur Sesame\n");
      system("PAUSE");
      InitGraphMode();
      AffichePresentation();
      AfficheCredits();
      return 2;
    }
    else
    {
      fscanf(frobot, "%u\n", & NombrePas);
      if(NombrePas == 0)
      {
        printf("Erreur nombre de pas nul\n");
        system("PAUSE");
        InitGraphMode();
        AffichePresentation();
        AfficheCredits();
        return 3;
      }
      else
      {
        if(ReinitSequence(pSequenceActuelle, NombrePas) == 0)
        {
          printf("! Erreur d'allocation 'chargement'. Peut-tre mmoire insuffisante...\n");
          system("PAUSE");
          InitGraphMode();
          AffichePresentation();
          AfficheCredits();
          return 4;
        }
        else
        {
          for(Pas = 0; Pas < pSequenceActuelle->N; Pas++)
          {
            fscanf(frobot, "%u\n", & pSequenceActuelle->R[Pas]);
            fscanf(frobot, "%u\n", & pSequenceActuelle->D[Pas]);
          }
          fclose(frobot);
          return 0;
        }
      }
    }
  }
}

/* -------------------------------------------------------- */
void AfficheFichiers(const char * mask, FileBut raison)
{
  int YaPu = 0;
  int x = 30;
  int y = 165;
  char * nom = NULL;
  struct ffblk FF;

  settextstyle(1, 0, 2);
  TraceFenetre(20, 135, 620, 425, LIGHTCYAN, BLUE);

  YaPu = findfirst(mask, & FF, 0);
  while(!YaPu)
  {
    if((nom = strtok(FF.ff_name, ".")) != NULL)
    {
      outtextxy(x, y, nom);
      nom = NULL;
    }
    y += 20;
    if(y == 405)
    {
      y = 165;
      x += 120;
    }
    YaPu = findnext(& FF);
  }
  settextstyle(1, 0, 2);
  TraceFenetre(115, 120, 525, 150, WHITE, BLUE);
  outtextxy(130, 125, TexteAfficheFichiers[raison]);
  TraceFenetre(160, 410, 472, 440, WHITE, BLUE);
  outtextxy(163, 414, "Nom du Fichier :");
}
/* -------------------------------------------------------- */
